---
title: XPathResult.iterateNext()
slug: Web/API/XPathResult/iterateNext
tags:
  - API
  - DOM XPath API
  - Method
  - Reference
  - XPath
  - XPathResult
---
<div>{{APIRef("DOM XPath")}}</div>

<p>The <strong><code>iterateNext()</code></strong> method of the {{domxref("XPathResult")}} interface iterates over a node set result and returns the next node from it or <code>null</code> if there are no more nodes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>node</var> = <var>result</var>.iterateNext();
</pre>

<h3 id="Return_Value">Return value</h3>

<p>The next {{domxref("Node")}} within the node set of the <code>XPathResult</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<h4 id="TYPE_ERR">TYPE_ERR</h4>

<p>In case {{domxref("XPathResult.resultType")}} is not <code>UNORDERED_NODE_ITERATOR_TYPE</code> or <code>ORDERED_NODE_ITERATOR_TYPE</code>, an {{domxref("XPathException")}} of type <code>TYPE_ERR</code> is thrown.</p>

<h4 id="INVALID_STATE_ERR">INVALID_STATE_ERR</h4>

<p>If the document is mutated since the result was returned, an {{domxref("XPathException")}} of type <code>INVALID_STATE_ERR</code> is thrown.</p>

<h2 id="Example">Example</h2>

<p>The following example shows the use of the <code>iterateNext()</code> method.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;XPath example&lt;/div&gt;
&lt;div&gt;Tag names of the matched nodes: &lt;output&gt;&lt;/output&gt;&lt;/div&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">var xpath = "//div";
var result = document.evaluate(xpath, document, null, XPathResult.ANY_TYPE, null);
var node = null;
var tagNames = [];
while(node = result.iterateNext()) {
  tagNames.push(node.localName);
}
document.querySelector("output").textContent = tagNames.join(", ");
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example', 400, 70)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 XPath", "xpath.html#XPathResult-iterateNext", "XPathResult.iterateNext()")}}</td>
   <td>{{Spec2("DOM3 XPath")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.XPathResult.iterateNext()")}}</p>
</div>
